diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index c211066d1..eeffad659 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -137,6 +137,7 @@ import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.ChunkLoader;
 import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.save.ISaveConverter;
 import net.minecraft.core.world.save.ISaveFormat;
@@ -219,6 +220,8 @@ public class Minecraft
     public HudIngame hudIngame;
     public boolean skipRenderWorld;
     public @Nullable HitResult objectMouseOver;
+    public boolean canBridge = false;
+    public @NotNull TilePos bridgePos = new TilePos();
     public @NotNull SoundEngine sndManager;
     public final @NotNull SubtitleTracker subtitleTracker = new SubtitleTracker();
     public final @NotNull TexturePackList texturePackList;
@@ -1206,50 +1209,25 @@ public class Minecraft
 
         boolean flag = true;
         if (this.objectMouseOver == null) {
-            bridge:
-            if (GameSettings.EASY_BRIDGE.value) {
-                if (clickType == 1) {
-                    if (this.thePlayer.xRot < 45) {
-                        break bridge;
-                    }
-                    List<AABBdc> cubes = this.thePlayer.world.getCubes(this.thePlayer, this.thePlayer.bb.translate(0, -1.0, 0.0, new AABBd()));
-                    if (cubes.isEmpty()) {
-                        break bridge;
-                    }
-                    AABBdc cube = cubes.get(0);
-                    if (cube == null) {
-                        break bridge;
-                    }
-                    final @NotNull TilePos tilePos = new TilePos(
-                        MathHelper.floor(this.thePlayer.x),
-                        MathHelper.floor(this.thePlayer.y - this.thePlayer.heightOffset - 0.25),
-                        MathHelper.floor(this.thePlayer.z)
-                    );
-
-                    Direction playerDirection = Direction.getHorizontalLockable(this.thePlayer);
-                    if (playerDirection.isVertical()) break bridge;
-                    Side side = playerDirection.side();
-
-                    double yPlaced = 0.5d;
-                    double xPlaced = 0.5d;
-                    ItemStack stack = this.thePlayer.inventory.getCurrentItem();
-                    int numItemsInStack = stack == null ? 0 : stack.stackSize;
-                    if (stack == null) {
-                        break bridge;
-                    }
-                    if (this.playerController.placeItemStackOnTile(this.thePlayer, this.currentWorld, stack, tilePos, side, xPlaced, yPlaced)) {
-                        this.playerController.swingItem(true);
-                    }
-                    if (stack.stackSize <= 0) {
-                        this.thePlayer.inventory.setCurrentItem(null);
-                    } else if (stack.stackSize != numItemsInStack) {
-                        this.worldRenderer.itemRenderer.updateEquippedItem();
-                    }
-                }
-            }
             if (clickType == 0 && attack) {
                 this.playerController.swingItem(true);
             }
+            if (clickType == 1 && this.canBridge) bridge: {
+                double yPlaced = 0.5d;
+                double xPlaced = 0.5d;
+                ItemStack stack = this.thePlayer.inventory.getCurrentItem();
+                int numItemsInStack = stack == null ? 0 : stack.stackSize;
+                if (stack == null) break bridge;
+
+                if (this.playerController.placeItemStackOnTile(this.thePlayer, this.currentWorld, stack, this.bridgePos, Side.TOP, xPlaced, yPlaced)) {
+                    this.playerController.swingItem(true);
+                }
+                if (stack.stackSize <= 0) {
+                    this.thePlayer.inventory.setCurrentItem(null);
+                } else if (stack.stackSize != numItemsInStack) {
+                    this.worldRenderer.itemRenderer.updateEquippedItem();
+                }
+            }
         } else if (this.objectMouseOver instanceof HitResult.Entity hitEntity) {
             if (clickType == 0 && attack) {
                 this.playerController.swingItem(true);
diff --git a/game/client/src/main/java/net/minecraft/client/enums/SelectedSoundtrack.java b/game/client/src/main/java/net/minecraft/client/enums/SelectedSoundtrack.java
new file mode 100644
index 000000000..0a341c879
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/enums/SelectedSoundtrack.java
@@ -0,0 +1,23 @@
+package net.minecraft.client.enums;
+
+import net.minecraft.client.sound.Soundtrack;
+import net.minecraft.core.util.helper.ITranslatable;
+
+public enum SelectedSoundtrack
+    implements ITranslatable
+{
+    MIXED(new Soundtrack[]{ Soundtrack.MINECRAFT, Soundtrack.BETTER_THAN_ADVENTURE }),
+    MINECRAFT(new Soundtrack[]{ Soundtrack.MINECRAFT }),
+    BETTER_THAN_ADVENTURE(new Soundtrack[]{ Soundtrack.BETTER_THAN_ADVENTURE });
+
+    public final Soundtrack[] soundtracks;
+
+    SelectedSoundtrack(final Soundtrack[] soundtracks) {
+        this.soundtracks = soundtracks;
+    }
+
+    @Override
+    public String getTranslationKey() {
+        return name().toLowerCase();
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 0b24fbbc7..c9d530942 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -125,6 +125,7 @@ public abstract class OptionsPages {
         AUDIO = register(new OptionsPage("gui.options.page.audio.title", new ItemStack(Items.RECORD_CAT))
             .withComponent(new OptionsCategory("gui.options.page.audio.category.audio")
                 .withComponent(new BooleanOptionComponent(GameSettings.SUBTITLES))
+                .withComponent(new ToggleableOptionComponent<>(GameSettings.SELECTED_SOUNDTRACK))
                 .withComponent(new ToggleableOptionComponent<>(GameSettings.MUSIC_FREQUENCY))
                 .withComponent(new BooleanOptionComponent(GameSettings.MUTE_ON_LOST_FOCUS))
                 .withComponent(new BooleanOptionComponent(GameSettings.PLAY_TITLE_SCREEN_MUSIC))
diff --git a/game/client/src/main/java/net/minecraft/client/input/InputHandler.java b/game/client/src/main/java/net/minecraft/client/input/InputHandler.java
index 603ca3d92..b50f7cde1 100644
--- a/game/client/src/main/java/net/minecraft/client/input/InputHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/input/InputHandler.java
@@ -6,8 +6,13 @@ import org.lwjgl.glfw.GLFW;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.input.controller.ControllerInput;
+import org.lwjgl.system.MemoryStack;
+import org.lwjgl.system.MemoryUtil;
 import org.slf4j.Logger;
 
+import java.io.BufferedReader;
+import java.io.InputStreamReader;
+
 public abstract class InputHandler {
 	private static final Logger LOGGER = LogUtils.getLogger();
 	private static Minecraft minecraft;
@@ -66,6 +71,28 @@ public abstract class InputHandler {
 	}
 
 	public static void initGLFW(Minecraft minecraft) throws Throwable {
+		updateMappings: {
+			StringBuilder mappingString = new StringBuilder();
+			try (var stream = Minecraft.class.getResourceAsStream("/controller_mappings.txt")) {
+				if (stream == null) {
+					LOGGER.error("Could not read stream for \"controller_mappings.txt\"!");
+					break updateMappings;
+				}
+				var reader = new BufferedReader(new InputStreamReader(stream));
+				String line;
+				while ((line = reader.readLine()) != null) {
+					mappingString.append(line).append("\n");
+				}
+			}
+
+			var bb = MemoryUtil.memASCII(mappingString);
+			if (!GLFW.glfwUpdateGamepadMappings(bb)) {
+				LOGGER.error("Failed to update controller mappings!");
+			} else {
+				LOGGER.info("Updated controller mappings");
+			}
+			MemoryUtil.memFree(bb);
+		}
 		int found = 0;
 		for (int i = GLFW.GLFW_JOYSTICK_1; i < GLFW.GLFW_JOYSTICK_LAST; i++) {
 			if (GLFW.glfwJoystickPresent(i) && GLFW.glfwJoystickIsGamepad(i)) {
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index 7710c043e..d2dd33b26 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -7,6 +7,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.ScaledResolution;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.enums.MusicFrequency;
+import net.minecraft.client.enums.SelectedSoundtrack;
 import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.gui.options.ScreenOptions;
@@ -329,7 +330,8 @@ public final class GameSettings {
     public static final @NotNull OptionBoolean MUSIC_TOASTS = register(new OptionBoolean("musicToasts", true));
     public static final @NotNull OptionEnum<MusicFrequency> MUSIC_FREQUENCY = register(new OptionEnum<>("musicFrequency", MusicFrequency.class, MusicFrequency.DEFAULT)
         .addOnChangeCallback((mc, option) -> mc.sndManager.resetMusicTicks()));
-
+    public static final @NotNull OptionEnum<SelectedSoundtrack> SELECTED_SOUNDTRACK = register(new OptionEnum<>("selectedSoundtrack", SelectedSoundtrack.class, SelectedSoundtrack.MIXED)
+            .addOnChangeCallback((mc, option) -> mc.sndManager.resetMusicTicks()));
     public static final @NotNull OptionBoolean ENABLE_DEV_RESOURCE_LOADING = register(new OptionBoolean("enableDevResourceLoading", false));
     public static final @NotNull OptionBoolean DOWNLOAD_SOUNDFILES = register(new OptionBoolean("downloadSoundfiles", true));
     public static final @NotNull OptionBoolean ALLOW_SOUND_OVERRIDES = register(new OptionBoolean("allowSoundOverrides", false));
